<template>
    <a-modal :open="modal.open" :title="modal.title" :width="640" :confirm-loading="modal.confirmLoading"
        :after-close="onAfterClose" :cancel-text="cancelText" :ok-text="okText" @ok="handleOk" @cancel="handleCancel">
        <a-spin :spinning="spining">
            <a-form ref="formRef" :model="formData" :rules="formRules">
                <a-card class="mb-8-2">
                    <a-row :gutter="12">
                        <a-col :span="24">
                            <a-form-item :label="'区域名称'" name="title">
                                <a-input :placeholder="'请输入区域名称'" v-model:value="formData.title"></a-input>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'区域排序'" name="sequence">
                                <a-input-number :placeholder="'请输入排序'" v-model:value="formData.sequence"
                                    style="width: 100%;"></a-input-number>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'区域联系人'" name="concatName">
                                <a-input :placeholder="'请输区域联系人'" v-model:value="formData.concatName"
                                    style="width: 100%;"></a-input>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'联系电话'" name="concatPhone">
                                <a-input :placeholder="'请输入联系电话'" v-model:value="formData.concatPhone"
                                    @input="formData.concatPhone = formData.concatPhone.replace(/[^0-9]/g, '')"
                                    style="width: 100%;" />
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'备注'" name="remark">
                                <a-textarea :placeholder="'请输备注'" v-model:value="formData.remark"
                                    style="width: 100%;"></a-textarea>
                            </a-form-item>
                        </a-col>
                        <a-col :span="24">
                            <a-form-item :label="'状态'" name="status">
                                <a-radio-group v-model:value="formData.status" :options="workTypeStatus.getAll()"
                                    disabled></a-radio-group>
                            </a-form-item>
                        </a-col>
                    </a-row>
                </a-card>
            </a-form>
        </a-spin>

    </a-modal>
</template>

<script setup>
import { cloneDeep } from 'lodash-es'
import { ref, onBeforeMount } from 'vue'
import { config } from '@/config'
import apis from '@/apis'
import { useForm, useModal, useSpining } from '@/hooks'
import { message } from 'ant-design-vue'
import { useI18n } from 'vue-i18n'
import { workTypeStatus } from '@/enums/index.js'
import { spliceUrl } from '@/utils/util'
const areaFormRef = ref()
const emit = defineEmits(['ok'])
const { t } = useI18n() // 解构出t方法
const { modal, showModal, hideModal, showLoading, hideLoading } = useModal()
const { formRecord, formData, formRef, formRules, resetForm } = useForm()
const { spining, showSpining, hideSpining } = useSpining()
const cancelText = ref(t('button.cancel'))
const okText = ref(t('button.confirm'))
const treeData = ref([])
formRules.value = {
    title: { required: true, message: '请输入区域名称' },
    sequence: { required: true, message: '请输入排序' },
    concatName: { required: true, message: '请输入联系人' },
    concatPhone: { required: true, message: '请输入联系电话' },
    status: { required: true, message: '请选择状态', trigger: 'change' }
}


/**
 * 新建
 */
function handleCreate() {
    showModal({
        type: 'create',
        title: '新增区域',
    })
    formData.value.status = 1
}

/**
 * 编辑
 */
async function handleEdit(record = {}) {
    showModal({
        type: 'edit',
        title: '编辑分类',
    })
    try {
        showSpining()
        const { data, success } = await apis.orderArea.getMenu(record.id).catch()
        if (!success) {
            hideModal()
            return
        }
        hideSpining()
        formData.value = { ...data }
    } catch (error) {
        message.error({ content: error.message })
        hideSpining()
    }
}
/**
 * 确定
 */
function handleOk() {
    formRef.value.validateFields().then(async (values) => {
        try {
            showLoading()
            const params = {
                ...values,
                status: 1
            }
            let result = null
            switch (modal.value.type) {
                case 'create':
                    result = await apis.orderArea.createMenu(params).catch((error) => {
                        throw new Error(error)
                    })
                    break
                case 'edit':
                    result = await apis.orderArea.updateMenu(formData.value.id, params).catch(() => {
                        throw new Error(error)
                    })
                    break
            }
            hideLoading()
            if (config('http.code.success') === result?.success) {
                hideModal()
                emit('ok')
            }
        } catch (error) {
            message.error({ content: error.message })
            hideLoading()
        }
    })
        .catch((e) => {
            hideLoading()
        })
}


/**
 * 取消
 */
function handleCancel() {
    hideModal()
}

/**
 * 关闭后
 */
function onAfterClose() {
    resetForm()
    hideLoading()
}

defineExpose({
    handleCreate,
    handleEdit,
})


</script>

<style lang="less" scoped></style>
